//+------------------------------------------------------------------+
 /////////////CYCLE TRIANGULAR CENTERED END-POINT  
 /////////////////////VERTICAL CROSSING
//////////////Sohocool May 2013
////# Cycle_Tma_End_Point_Vertical_Crossing

//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright ""
#property  link      ""
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Gold
#property  indicator_color2  Gold
#property  indicator_color3  Red
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2

#property  indicator_level1 0
//---- indicator parameters
extern int Fast_HalfLength=12;
extern int Slow_HalfLength=24;
extern int PRICE = 0;

//---- indicator buffers
double     MacdBuffer[];
double     HistogramBuffer1[];
double     HistogramBuffer2[];
double  slope[];
//---- globals
int        maxLines;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   //
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,HistogramBuffer1);
   SetIndexBuffer(2,HistogramBuffer2);
   SetIndexBuffer(3,slope);
   //
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Histo +");
   SetIndexLabel(2,"Histo -");
   //
   //SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
   IndicatorShortName("Cycle_Tma_End_Point("+Fast_HalfLength+","+Slow_HalfLength+","+PRICE+"");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   DeleteLines();
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double crossing;
   int limit,i;
   int counted_bars=IndicatorCounted();
//----
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
   for(i=0; i<limit; i++) MacdBuffer[i]=iMA(NULL,0,Fast_HalfLength+1,0,3,PRICE,i)-iMA(NULL,0,Slow_HalfLength+1,0,3,PRICE,i);
     //for(i=0; i<limit; i++) 
     //{
     // SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
     // HistogramBuffer[i]=MacdBuffer[i] ;
     //}
    // for(i=limit; i>=0; i--) 
    for(i=0; i<limit; i++)
   {
      HistogramBuffer1[i]=EMPTY_VALUE;
     HistogramBuffer2 [i]=EMPTY_VALUE;      
      slope[i] = slope[i+1];
         if (MacdBuffer[i]>MacdBuffer[i+1]) slope[i] = 1;
         if (MacdBuffer[i]<MacdBuffer[i+1]) slope[i] =-1;
         if (slope[i] == 1) HistogramBuffer1[i]=MacdBuffer[i];
         if (slope[i] ==-1) HistogramBuffer2[i]=MacdBuffer[i];
   } 
//----
   DeleteLines();
   for(i=WindowBarsPerChart(); i>0 ;i--)
     {
      crossing=((MacdBuffer[i])*(MacdBuffer[i+1]));
      if (crossing <= 0)
        {
         maxLines+=1;
         ObjectCreate("MacdCross"+maxLines,0,0,Time[i],0);
         ObjectSet("MacdCross"+maxLines,OBJPROP_COLOR,DimGray);
         ObjectSet("MacdCross"+maxLines,OBJPROP_STYLE,STYLE_DOT);
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteLines()
  {
   for(int i=1;i<=maxLines;i++) ObjectDelete("MacdCross"+i); maxLines=0;
  }
//+------------------------------------------------------------------+